import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService, FrameworkErrorEnum, ServiceError } from 'free-midway-component';
import { Studio } from '../entity/studio.entity';
type modelType = ReturnModelType<typeof Studio>;
@Provide()
export class StudioService extends BaseService<modelType> {
  @InjectEntityModel(Studio)
  model: modelType;
  async create(body){
    const data = await this.model.findOne({ name: body.name });
    if (!data) {
      const res = await this.model.create(body);
      return res;
    }
    throw new ServiceError('工作室名称已被占用', FrameworkErrorEnum.SERVICE_FAULT);
  }
}
